#include "WLANWatch-Client.h"

extern char	*src_ip;
extern char	*dst_ip;
extern int	src_port;
extern int	dst_port;
extern int	SEQUENCE_NUM_START;
extern int	SEQUENCE_NUM_SIZE;
extern int	SEQUENCE_NUM_REDUNDANCY;
extern int	UDP_PACKET_DATA_SIZE;
extern int	TRAFFIC_COUNT;
extern int	REPEAT_TEST;
extern int      statusPipe[];
extern int      hintPipe[];
extern int      oopsPipe[];
extern int	clientUp;

extern int	TxLogerpid;
extern int	WLANWatchCsockfd;

extern void     writeToPipe(int fd, char *str);

static char     mesg[300];

int TrafficGenerator(void);

int TrafficGenerator()
{
	int			TGsockfd, bind_ret;
	int			i,j,seqno,num,len;
	char			buf[MAXPACKETSIZE];
	char			random_buf[MAXPACKETSIZE];
	char			seq_str[10];
	char			zeros[10];
	struct sockaddr_in 	src_addr;
	struct sockaddr_in 	dst_addr;
	fd_set			fds;
	
	FD_ZERO(&fds);
	FD_SET(0, &fds);

	memset(&src_addr, 0, sizeof(src_addr));	
	memset(&dst_addr, 0, sizeof(dst_addr));	

	inet_aton(src_ip, &src_addr.sin_addr);	
	inet_aton(dst_ip, &dst_addr.sin_addr);	

	src_addr.sin_family = AF_INET;
	src_addr.sin_port = htons(src_port);	

	dst_addr.sin_family = AF_INET; 
	dst_addr.sin_port = htons(dst_port);	

	TGsockfd = socket(PF_INET, SOCK_DGRAM, 0);
	if(TGsockfd == -1){
		strcpy(mesg, "TrafficGenerator: socket syscall failed...\n");
		writeToPipe(oopsPipe[1], mesg);
		goto cleanup;
	}

	bind_ret = bind(TGsockfd, (struct sockaddr *) &src_addr, sizeof(src_addr));
	if(bind_ret == -1){
		strcpy(mesg, "TrafficGenerator: bind failed...\n");
		writeToPipe(oopsPipe[1], mesg);
		goto cleanup;
	}
	
	if(connect(TGsockfd, (struct sockaddr *) &dst_addr, sizeof(dst_addr))  != 0){
		sprintf(mesg, "connect failed...\n");
		writeToPipe(oopsPipe[1], mesg);
		goto cleanup;
	}
		
	strcpy(mesg, "Traffic Generator Started...\n");
	writeToPipe(statusPipe[1], mesg);
	
	/* Pump the traffic through the Wireless interface */
	for(i=1, seqno=SEQUENCE_NUM_START; i<=TRAFFIC_COUNT && clientUp == 1; i++, seqno++){
		zeros[0]='\0';
		sprintf(seq_str, "%d", seqno);

		/* 
		 * Append appropriate number of zeros to each instance of 
		 * sequence number to make it SEQUENCE_NUM_SIZE long
		 */
		for(j=0; j<SEQUENCE_NUM_SIZE-strlen(seq_str); j++)
			strcat(zeros,"0");
		strcat(zeros, seq_str);
		strcpy(seq_str, zeros);

		/* 
		 * The sequence number should appear SEQUENCE_NUM_REDUNDANCY 
		 * times in each packet
		 */
		strcpy(buf, seq_str);
		for(j=1; j<SEQUENCE_NUM_REDUNDANCY-1; j++)
			strcat(buf, seq_str);

		len = strlen(buf);

		/* Generate a random buffer only once in the case of a REPEAT_TEST */
		if( !REPEAT_TEST || (REPEAT_TEST && (i==1)) ){
			for(j=0; j<UDP_PACKET_DATA_SIZE-len-strlen(seq_str); j++){
				random_buf[j] = random()%255 + 1;	// Make sure ZERO which stands for NULL ('\0') doesnt get in.
			}		
			random_buf[j] = '\0';
		}
		strcat(buf, random_buf);
		strcat(buf, seq_str);
		
//		select(TGsockfd + 1, NULL, &fds, NULL, NULL);
//		num = sendto(TGsockfd,(const void *)buf, strlen(buf), MSG_DONTWAIT, (struct sockaddr *)&dst_addr, sizeof(dst_addr));
//		num = sendto(TGsockfd,(const void *)buf, strlen(buf), 0, (struct sockaddr *)&dst_addr, sizeof(dst_addr));
		
		num = send(TGsockfd, (const void *)buf, strlen(buf), 0);

		/* Create some delay for REPEAT_TEST*/	
//		if(REPEAT_TEST)
//			for(j=1; j<30000; j++)
//				;
	}

	strcpy(mesg, "Traffic Generator Stopped...\n");
	writeToPipe(statusPipe[1], mesg);

	close(TGsockfd);	
	if(!clientUp)
		goto cleanup;
	
	return 0;
	
cleanup:
	strcpy(mesg, "Cleaning up Traffic Generator...\n\n");
	writeToPipe(statusPipe[1], mesg);

	/* Stop the TxLoger */
	if(kill(TxLogerpid, SIGINT)){
		strcpy(mesg, "CouldNot kill The Tx Loger...\n");
		writeToPipe(oopsPipe[1], mesg);
		
	}
	strcpy(mesg, "TxLoger Stopped...\n\n");
	writeToPipe(statusPipe[1], mesg);

	/* wait for the child to get terminated */	
	wait(NULL);

	close(WLANWatchCsockfd);
	WLANWatchCsockfd = 0;
	return -1;
}
