#include "WLANWatch-Client.h"

extern char	*ifname;
extern char	*src_ip;
extern char	*tcpdump_path;
extern int      statusPipe[];
extern int      hintPipe[];
extern int      oopsPipe[];

extern char	TxLog_temp[];
extern int	WLANWatchCsockfd;

extern void     writeToPipe(int fd, char *str);

static char     mesg[300];

pid_t           TxLogerpid;

void kill_TxLoger(int);
int TxLoger_Start(void);

/* signal (SIGINT) handler for TxLoger */
void kill_TxLoger(int a)
{
	/* close the write descriptor of the TxLoger */
	close(1);
	/* exit the TxLoger */		
	exit(0);
}

int TxLoger_Start()
{
	char		*tok;
	char		cmd[25];
	char		buf[MAXLINELENGTH];
	char		*argv[15];
	
	int		i, fd;

	strcpy(buf, "tcpdump -i ");
	strcat(buf, ifname);
	strcat(buf, " -e -nn -s 0 -t -x -p");
	strcat(buf, " src ");
	strcat(buf, src_ip);

	for(i=0; i<15; i++)
		argv[i] = (char *)malloc(25);

	/* argv[0] holds "tcpdump", the executable name */
	tok = strtok(buf, " ");
	strcpy(argv[0], tok);
	
	i = 0;
	while( (tok=strtok(NULL, " ")) != NULL){
		strcpy(argv[++i], tok);
	}
	/* important */
	argv[i+1] = NULL; 

	/* cmd holds the absolute path of the executable */
	strcpy(cmd, tcpdump_path);
//	sprintf(cmd, "/usr/sbin/%s", argv[0]); 

	if( (TxLogerpid=fork()) == 0 ){
		/* Print whatever to the screen before closing the write desc of the process below */
//		printf("TxLoger Started...\n");
		strcpy(mesg, "TxLoger Started...\n");
		writeToPipe(statusPipe[1], mesg);
						
		/* 
		 * setup the signal handler for catching SIGINT which will be 
		 * used by the TrafficGenerator to stop the TxLoger.
		 */
		signal(SIGINT, kill_TxLoger);
		
		/* open the temp file for writing the output */
		fd = open(TxLog_temp, O_RDWR|O_CREAT|O_TRUNC, S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH);
	
		/* close the default write descriptor.
		 * Make the write desc point to the above opened file. 
		 * Now the output is shifted to the TxLog_temp file.
		 */
		if(dup2(fd, 1) != 1){
			sprintf(mesg, "dup2 failed. Couldnt make the tcpdump write to %s...\n", TxLog_temp);
			writeToPipe(oopsPipe[1], mesg);
			exit(-1);
		}

		/* close the default stderr descriptor */	
		close(2);

		/* execute tcpdump to log the traffic */
		execv(cmd, argv);

		/* exec functions never return on success */
		
		strcpy(mesg, "'execv tcpdump' failed...\n");
		writeToPipe(oopsPipe[1], mesg);
		strcpy(mesg, "Make sure the 'Complete Path To \"tcpdump\"' is valid...\n");
		writeToPipe(hintPipe[1], mesg);
	/* Cannot use printf here as the write desc is closed above */
		exit(-1);
	}else
		if(TxLogerpid > 0){	/* Let the TxLoger start up */
			sleep(1);
		}
		else{
			strcpy(mesg, "TxLoger: fork failed\n");
			writeToPipe(oopsPipe[1], mesg);

			close(WLANWatchCsockfd);
			WLANWatchCsockfd = 0;
			return -1;
		}		
	return 0;
}
