#include "WLANWatch-Client.h"

extern int	remote_sniff_channel;
extern int      statusPipe[];
extern int      hintPipe[];
extern int      oopsPipe[];

extern char	START_SNIFFING[];
extern int	WLANWatchCsockfd;
extern char	sniff_MAC[];
extern void     writeToPipe(int fd, char *str);

static char     mesg[300];

extern int	sendCommand(int, char *, int);
extern int	readResponse(int, char *, int);

int WLANWatchC_StartSniffer(void);

int WLANWatchC_StartSniffer()
{
	int	n;
	char	temp[5];
	char	buf[COMMAND_SIZE];

	strcpy(buf, START_SNIFFING);
	n = strlen(buf);
	sprintf(mesg, "WLANWatchC_StartSniffer: sending --> %s", buf);
	writeToPipe(statusPipe[1], mesg);
	
	if(sendCommand(WLANWatchCsockfd, buf, n) != n){
		strcpy(mesg, "sendCommand error...\n");
		writeToPipe(oopsPipe[1], mesg);
		return -1;
	}
	/* START_SNIFFING has 2 parameters */
	/* Channel number */
	sprintf(temp, "%d\n", remote_sniff_channel);
	strcpy(buf, temp);
	n = strlen(buf);
	sprintf(mesg, "WLANWatchC_StartSniffer: sending --> %s", buf);
	writeToPipe(statusPipe[1], mesg);
	if(sendCommand(WLANWatchCsockfd, buf, n) != n){
		strcpy(mesg, "sendCommand error...\n");
		writeToPipe(oopsPipe[1], mesg);
		return -1;
	}
	/* MAC to be sniffed */
	strcpy(buf, sniff_MAC); 
	n = strlen(buf);
	sprintf(mesg, "WLANWatchC_StartSniffer: sending --> %s", buf);
	writeToPipe(statusPipe[1], mesg);
	if(sendCommand(WLANWatchCsockfd, buf, n) != n){
		strcpy(mesg, "sendCommand error...\n");
		writeToPipe(oopsPipe[1], mesg);
		return -1;
	}
	/* Read Response */
	n = readResponse(WLANWatchCsockfd, buf, COMMAND_SIZE);
	sprintf(mesg, "WLANWatchC_StartSniffer: received <%s>\n\n", buf);
	writeToPipe(statusPipe[1], mesg);
	
	if(n < 0){
		strcpy(mesg, "readResponse error...\n");
		writeToPipe(oopsPipe[1], mesg);
		return -1;
	}
	if(n == 0){
		strcpy(mesg, "Connection closed by the WLANWatch Server...\n");
		writeToPipe(statusPipe[1], mesg);
		strcpy(mesg, "The WLANWatch Server might have gone down. Go Check Out...\n");
		writeToPipe(hintPipe[1], mesg);
	
		close(WLANWatchCsockfd);	
		WLANWatchCsockfd = 0;
		return -1;
	}

	if(!strcmp(buf, "COMMAND_FAILED")){
		strcpy(mesg, "START_SNIFFING : COMMAND_FAILED...\n");
		writeToPipe(oopsPipe[1], mesg);
		strcpy(mesg, "Terminating the current session...\n");
		writeToPipe(statusPipe[1], mesg);

		close(WLANWatchCsockfd);	
		WLANWatchCsockfd = 0;
		return -1;
	}
	if(!strcmp(buf, "COMMAND_ACCEPTED")){
		return 0;
	}

	/* Something unexpected */	
	sprintf(mesg, "Unknown Response : WLANWatch Server sent '%s'...\n\n", buf);
	writeToPipe(oopsPipe[1], mesg);
	strcpy(mesg, "Is Imtiaz Around?...\n");
	writeToPipe(hintPipe[1], mesg);
	
	/* close the connection with the WLANWatchS */
        strcpy(mesg, "Terminating the current session...\n");
        writeToPipe(statusPipe[1], mesg);

	close(WLANWatchCsockfd);
	WLANWatchCsockfd = 0;
	return -1;
}
