#include "WLANWatch-Client.h"

extern int      statusPipe[];
extern int      hintPipe[];
extern int      oopsPipe[];

extern int	WLANWatchCsockfd;
extern char	STOP_SNIFFING[];

extern void     writeToPipe(int fd, char *str);

extern int	sendCommand(int, char*, int);
extern int	readResponse(int, char*, int);

static char     mesg[300];

int WLANWatchC_StopSniffer(void);

int WLANWatchC_StopSniffer()
{
	int	n;
	char    buf[COMMAND_SIZE];
		
	strcpy(buf, STOP_SNIFFING);
	n = strlen(buf);
	sprintf(mesg, "WLANWatchC_StopSniffer: sending --> %s", buf);
	writeToPipe(statusPipe[1], mesg);
	
	if(sendCommand(WLANWatchCsockfd, buf, n) != n){
		strcpy(mesg, "sendCommand error...\n");
		writeToPipe(oopsPipe[1], mesg);
		return -1;
	}

	/* Read Response */
	n = readResponse(WLANWatchCsockfd, buf, sizeof(buf));
        sprintf(mesg, "WLANWatchC_StopSniffer: received <%s>\n\n", buf);
        writeToPipe(statusPipe[1], mesg);

	if(n < 0){
		strcpy(mesg, "readResponse error...\n");
		writeToPipe(oopsPipe[1], mesg);
		return -1;
	}
	if(n == 0){
                strcpy(mesg, "Connection closed by the WLANWatch Server...\n");
                writeToPipe(statusPipe[1], mesg);
                strcpy(mesg, "The WLANWatch Server might have gone down. Go Check Out...\n");
                writeToPipe(hintPipe[1], mesg);

		close(WLANWatchCsockfd);
		WLANWatchCsockfd = 0;
		return -1;
	}

	if(!strcmp(buf, "COMMAND_FAILED")){
		return -1;
	}
	if(!strcmp(buf, "COMMAND_ACCEPTED")){
		return 0;
	}

	/* Something unexpected */	
        sprintf(mesg, "Unknown Response : WLANWatch Server sent '%s'...\n\n", buf);
        writeToPipe(oopsPipe[1], mesg);
        strcpy(mesg, "Is Imtiaz Around?...\n");
        writeToPipe(hintPipe[1], mesg);

	/* close the connection with the WLANWatchS */
        strcpy(mesg, "Closing the current session...\n");
        writeToPipe(statusPipe[1], mesg);

	close(WLANWatchCsockfd);
	WLANWatchCsockfd = 0;
	return -1;
}
