#include "WLANWatch-Client.h"

extern int      statusPipe[];
extern int      hintPipe[];
extern int      oopsPipe[];
extern int	clientUp;

extern int      WLANWatchCsockfd;

extern void     writeToPipe(int fd, char *str);

extern char	RxLog[];
extern char	IMPORT_RXLOG[];
extern int      sendCommand(int, char *, int);
extern int      readResponse(int, char *, int);

static char     mesg[300];

static int	readFile(void);
int		import_RxLog(void);

static int readFile()
{
	FILE	*fp;
	char	buf[MAXLINELENGTH];
	int	size, n, i;
	char	c;

	fp = fopen(RxLog, "w+");
	if(fp == NULL){
		strcpy(mesg, "import_RxLog: fopen failed...\n");
		writeToPipe(oopsPipe[1], mesg);
		return -1;
	}
	sprintf(mesg, "Importing %s...\n", RxLog);
	writeToPipe(statusPipe[1], mesg);
	
	/* First read the size of file in bytes */
	n = readResponse(WLANWatchCsockfd, buf, sizeof(buf));
	if(!n){	/* Connection closed by WLANWatchS */
                strcpy(mesg, "Connection closed by the WLANWatch Server...\n");
                writeToPipe(statusPipe[1], mesg);
                strcpy(mesg, "The WLANWatch Server might have gone down. Go Check Out...\n");
                writeToPipe(hintPipe[1], mesg);

		close(WLANWatchCsockfd);
		WLANWatchCsockfd = 0;
		fclose(fp);
		return -1;
	}
	size = atoi(buf);
	sprintf(mesg, "File size (in bytes) : %d\n", size);
	writeToPipe(statusPipe[1], mesg);
	
	/* Then the file contents... */
	for(i=1; i<=size && clientUp == 1; i++){
		if((n = read(WLANWatchCsockfd, &c, 1)) == 1){
			fprintf(fp, "%c", c);
		}else
			if(n == 0){ /* Connection closed by WLANWatchS */
				strcpy(mesg, "Connection closed by the WLANWatch Server...\n");
				writeToPipe(statusPipe[1], mesg);
				strcpy(mesg, "The WLANWatch Server might have gone down. Go Check Out...\n");
				writeToPipe(hintPipe[1], mesg);

				close(WLANWatchCsockfd);
				WLANWatchCsockfd = 0;
				fclose(fp);
				return -1;
			}else{ /* Error */
				strcpy(mesg, "import_RxLog: readFile error...\n");
				writeToPipe(oopsPipe[1], mesg);
				
				return -1;             
			}
	}
	if(!clientUp)
		return -1;

	strcpy(mesg, "Done.\n");
	writeToPipe(statusPipe[1], mesg);

	fclose(fp);
	return 0;
}

int import_RxLog()
{
	int	n;
	char	buf[COMMAND_SIZE];	

	strcpy(buf, IMPORT_RXLOG);
	n = strlen(buf);
	sprintf(mesg, "WLANWatchC_import_RxLog: sending --> %s", buf);
	writeToPipe(statusPipe[1], mesg);

	if(sendCommand(WLANWatchCsockfd, buf, n) != n){
		strcpy(mesg, "sendCommand error...\n");
		writeToPipe(oopsPipe[1], mesg);
		return -1;
	}

	/* Read Response */
	n = readResponse(WLANWatchCsockfd, buf, COMMAND_SIZE);
	sprintf(mesg, "WLANWatchC_import_RxLog: received <%s>\n\n", buf);
	writeToPipe(statusPipe[1], mesg);
	
	if(n < 0){
                strcpy(mesg, "readResponse error...\n");
                writeToPipe(oopsPipe[1], mesg);
		return -1;
	}

	if(n == 0){
                strcpy(mesg, "Connection closed by the WLANWatch Server...\n");
                writeToPipe(statusPipe[1], mesg);
                strcpy(mesg, "The WLANWatch Server might have gone down. Go Check Out...\n");
                writeToPipe(hintPipe[1], mesg);

		close(WLANWatchCsockfd);
		WLANWatchCsockfd = 0;
		return -1;
	}

	if(!strcmp(buf, "STOP_SNIFFING")){
		return 0;
	}

	if(!strcmp(buf, "COMMAND_ACCEPTED")){
		/* Read File */
		if(readFile() == -1)
			goto cleanup;
		else
			return 0;
	}

	if(!strcmp(buf, "COMMAND_FAILED")){
	        strcpy(mesg, "Closing the current session...\n");
	        writeToPipe(statusPipe[1], mesg);

		close(WLANWatchCsockfd);
		WLANWatchCsockfd = 0;
		return -1;
	}

	/* Something unexpected */	
        sprintf(mesg, "Unknown Response : WLANWatch Server sent '%s'...\n\n", buf);
        writeToPipe(oopsPipe[1], mesg);
        strcpy(mesg, "Is Imtiaz Around?...\n");
        writeToPipe(hintPipe[1], mesg);

cleanup:	
	/* close the connection with the WLANWatchS */
	strcpy(mesg, "Terminating the current session...\n\n");
	writeToPipe(statusPipe[1], mesg);

	close(WLANWatchCsockfd);
	WLANWatchCsockfd = 0;
	return -1;
}
