/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gnome.h>

#include "interface.h"
#include "support.h"

#include "WLANWatch-Client.h"

/*------------------------------*/
/*	WLANWatchC Main Page		*/
/*------------------------------*/
GtkText         *status_text;
GtkText         *hint_text;
GtkText         *oops_text;

/*------------------------------*/
/*	WLANWatchC Traffic Parameters	*/
/*------------------------------*/
char		*dst_ip;
int		src_port;
int		dst_port;
int		SEQUENCE_NUM_START;
int		SEQUENCE_NUM_SIZE;
int		SEQUENCE_NUM_REDUNDANCY;
int		UDP_PACKET_DATA_SIZE;	
int		TRAFFIC_COUNT;
int		remote_sniff_channel;
int		REPEAT_TEST;

/*------------------------------*/
/*	WLANWatchC Configuration	*/
/*------------------------------*/
char		*serverIP;
int		SERV_TCP_PORT;
int		nic;
char		*ifname;
char		*src_ip;
char		*tcpdump_path;

/*------------------------------*/
/*	NIC Setup		*/
/*------------------------------*/
char		*c_ifname;
char		*c_ip;
char		*c_mask;
char		*c_gw;
char		*c_driver;
char		*c_ssid;

char		*p_ifname;
char		*p_ip;
char		*p_mask;
char		*p_gw;
char		*p_driver;
char		*p_ssid;
/*------------------------------*/

GtkWidget	*WLANWatch_Client;
int		clientUp;
int             statusPipe[2];
int		hintPipe[2];
int		oopsPipe[2];

int		stats_clicked;

pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;

static char     mesg[300];
static struct   itimerval timer;

static void	on_contents_option_selected(GtkMenuShell *menu_shell, gpointer user_data);
static void	on_nic_option_selected(GtkMenuShell *menu_shell, gpointer user_data);
static void	update_windows(int);

int
main (int argc, char *argv[])
{
	GtkWidget               *option_menu;
	GtkOptionMenu           *opt_menu;
	GtkWidget               *text_entry = NULL;

	FILE                    *fp;
	char                    *buff = (char *)malloc(100*sizeof(char));
	char                    temp[50];

#ifdef ENABLE_NLS
	bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
	textdomain (PACKAGE);
#endif

	gnome_init ("wlanwatch-client", VERSION, argc, argv);
	fp = fopen(".WLANWatch-client.conf", "r");
	if(fp == NULL){
		fp = fopen(".WLANWatch-server.conf", "w+");
		dst_ip			=	g_strdup("");
		src_port		=	6666;	
		dst_port		=	6666;
		SEQUENCE_NUM_START	=	0;
		SEQUENCE_NUM_SIZE	=	6;
		SEQUENCE_NUM_REDUNDANCY	=	3;
		UDP_PACKET_DATA_SIZE	=	100;	
		TRAFFIC_COUNT		=	2000;
		remote_sniff_channel	=	6;
		REPEAT_TEST		=	0;
		
		serverIP		=	g_strdup("");
		SERV_TCP_PORT		=	6060;
		nic			=	0;
		ifname			=	g_strdup("eth1");
		src_ip			=	g_strdup("");
		tcpdump_path		=	g_strdup("/usr/sbin/tcpdump");

		c_ifname		=	g_strdup("eth1");
		c_ip			=	g_strdup("");
		c_mask			=	g_strdup("");
		c_gw			=	g_strdup("");
		c_driver		=	g_strdup("airo");
		c_ssid			=	g_strdup("My Access Point");

		p_ifname		=	g_strdup("wlan0");
		p_ip			=	g_strdup("");
		p_mask			=	g_strdup("");
		p_gw			=	g_strdup("");
		p_driver		=	g_strdup("prism2_plx");
		p_ssid			=	g_strdup("My Access Point");
	}else{
		fgets(buff,100,fp);
		dst_ip			=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		src_port		=	atoi(buff);

		fgets(buff, 100, fp);
		dst_port		=	atoi(buff);

		fgets(buff, 100, fp);
		SEQUENCE_NUM_START	=	atoi(buff);

		fgets(buff, 100, fp);
		SEQUENCE_NUM_SIZE	=	atoi(buff);

		fgets(buff, 100, fp);
		SEQUENCE_NUM_REDUNDANCY	=	atoi(buff);

		fgets(buff, 100, fp);
		UDP_PACKET_DATA_SIZE	=	atoi(buff);

		fgets(buff, 100, fp);
		TRAFFIC_COUNT		=	atoi(buff);

		fgets(buff, 100, fp);
		remote_sniff_channel	=	atoi(buff);

		fgets(buff, 100, fp);
		REPEAT_TEST		=	atoi(buff);

		fgets(buff,100,fp);
		serverIP		=	g_strdup(g_strstrip(buff));

		fgets(buff,100,fp);
		SERV_TCP_PORT		=	atoi(buff);	

		fgets(buff,100,fp);
		nic			=	0;
		if(g_strcasecmp(g_strstrip(buff), "1") == 0)
		nic			=	1;

		fgets(buff, 100, fp);
		ifname			=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		src_ip			=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		tcpdump_path		=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		c_ifname		=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		c_ip			=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		c_mask			=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		c_gw			=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		c_driver		=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		c_ssid			=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		p_ifname		=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		p_ip			=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		p_mask			=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		p_gw			=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		p_driver		=	g_strdup(g_strstrip(buff));

		fgets(buff, 100, fp);
		p_ssid			=	g_strdup(g_strstrip(buff));
	}
	free(buff);
	fclose(fp);

	/* create the 'log' directory - if it doesnt exist. */
	fp = popen("mkdir log", "r");
	pclose(fp);
	
	clientUp = 0;
	stats_clicked = 0;

	WLANWatch_Client = create_WLANWatch_Client();
	gtk_widget_show (WLANWatch_Client);

	/* Set up handler for the contents & nic option menu. */
	option_menu = lookup_widget(WLANWatch_Client, "Traffic_optmenu");
	gtk_signal_connect(GTK_OBJECT(GTK_OPTION_MENU(option_menu)->menu), "deactivate",
	GTK_SIGNAL_FUNC(on_contents_option_selected),NULL);

	option_menu = lookup_widget(WLANWatch_Client, "nic_optmenu");
	gtk_signal_connect(GTK_OBJECT(GTK_OPTION_MENU(option_menu)->menu), "deactivate",
	GTK_SIGNAL_FUNC(on_nic_option_selected),NULL);

	/* Set up the default values (indices) of the option menus. */
	opt_menu = GTK_OPTION_MENU(lookup_widget(WLANWatch_Client, "Traffic_optmenu"));
	gtk_option_menu_set_history(opt_menu, REPEAT_TEST);

	opt_menu = GTK_OPTION_MENU(lookup_widget(WLANWatch_Client, "nic_optmenu"));
	gtk_option_menu_set_history(opt_menu, nic);

	/* Set up the default values of all other fields */
	text_entry = lookup_widget(WLANWatch_Client, "dst_ip");
	gtk_entry_set_text(GTK_ENTRY(text_entry), dst_ip);

	sprintf(temp, "%d", src_port);
	text_entry = lookup_widget(WLANWatch_Client, "src_port");
	gtk_entry_set_text(GTK_ENTRY(text_entry), temp);

	sprintf(temp, "%d", dst_port);
	text_entry = lookup_widget(WLANWatch_Client, "dst_port");
	gtk_entry_set_text(GTK_ENTRY(text_entry), temp);

	sprintf(temp, "%d", SEQUENCE_NUM_START);
	text_entry = lookup_widget(WLANWatch_Client, "SEQUENCE_NUM_START");
	gtk_entry_set_text(GTK_ENTRY(text_entry), temp);

	sprintf(temp, "%d", SEQUENCE_NUM_SIZE);
	text_entry = lookup_widget(WLANWatch_Client, "SEQUENCE_NUM_SIZE");
	gtk_entry_set_text(GTK_ENTRY(text_entry), temp);

	sprintf(temp, "%d", SEQUENCE_NUM_REDUNDANCY);
	text_entry = lookup_widget(WLANWatch_Client, "SEQUENCE_NUM_REDUNDANCY");
	gtk_entry_set_text(GTK_ENTRY(text_entry), temp);

	sprintf(temp, "%d", UDP_PACKET_DATA_SIZE);
	text_entry = lookup_widget(WLANWatch_Client, "UDP_PACKET_DATA_SIZE");
	gtk_entry_set_text(GTK_ENTRY(text_entry), temp);

	sprintf(temp, "%d", TRAFFIC_COUNT);
	text_entry = lookup_widget(WLANWatch_Client, "TRAFFIC_COUNT");
	gtk_entry_set_text(GTK_ENTRY(text_entry), temp);

	sprintf(temp, "%d", remote_sniff_channel);
	text_entry = lookup_widget(WLANWatch_Client, "remote_sniff_channel");
	gtk_entry_set_text(GTK_ENTRY(text_entry), temp);

	text_entry = lookup_widget(WLANWatch_Client, "serverIP");
	gtk_entry_set_text(GTK_ENTRY(text_entry), serverIP);

	sprintf(temp, "%d", SERV_TCP_PORT);
	text_entry = lookup_widget(WLANWatch_Client, "SERV_TCP_PORT");
	gtk_entry_set_text(GTK_ENTRY(text_entry), temp);

	text_entry = lookup_widget(WLANWatch_Client, "ifname");
	gtk_entry_set_text(GTK_ENTRY(text_entry), ifname);

	text_entry = lookup_widget(WLANWatch_Client, "src_ip");
	gtk_entry_set_text(GTK_ENTRY(text_entry), src_ip);

	text_entry = lookup_widget(WLANWatch_Client, "tcpdump_path");
	gtk_entry_set_text(GTK_ENTRY(text_entry), tcpdump_path);

	text_entry = lookup_widget(WLANWatch_Client, "c_ifname");
	gtk_entry_set_text(GTK_ENTRY(text_entry), c_ifname);

	text_entry = lookup_widget(WLANWatch_Client, "c_ip");
	gtk_entry_set_text(GTK_ENTRY(text_entry), c_ip);

	text_entry = lookup_widget(WLANWatch_Client, "c_mask");
	gtk_entry_set_text(GTK_ENTRY(text_entry), c_mask);

	text_entry = lookup_widget(WLANWatch_Client, "c_gw");
	gtk_entry_set_text(GTK_ENTRY(text_entry), c_gw);

	text_entry = lookup_widget(WLANWatch_Client, "c_driver");
	gtk_entry_set_text(GTK_ENTRY(text_entry), c_driver);

	text_entry = lookup_widget(WLANWatch_Client, "c_ssid");
	gtk_entry_set_text(GTK_ENTRY(text_entry), c_ssid);

	text_entry = lookup_widget(WLANWatch_Client, "p_ifname");
	gtk_entry_set_text(GTK_ENTRY(text_entry), p_ifname);

	text_entry = lookup_widget(WLANWatch_Client, "p_ip");
	gtk_entry_set_text(GTK_ENTRY(text_entry), p_ip);

	text_entry = lookup_widget(WLANWatch_Client, "p_mask");
	gtk_entry_set_text(GTK_ENTRY(text_entry), p_mask);

	text_entry = lookup_widget(WLANWatch_Client, "p_gw");
	gtk_entry_set_text(GTK_ENTRY(text_entry), p_gw);

	text_entry = lookup_widget(WLANWatch_Client, "p_driver");
	gtk_entry_set_text(GTK_ENTRY(text_entry), p_driver);

	text_entry = lookup_widget(WLANWatch_Client, "p_ssid");
	gtk_entry_set_text(GTK_ENTRY(text_entry), p_ssid);

	/* Setup pointers to various windows to be updated */
	status_text = lookup_widget(WLANWatch_Client, "status");
	hint_text = lookup_widget(WLANWatch_Client, "hint");
	oops_text = lookup_widget(WLANWatch_Client, "oops");

	if(pipe(statusPipe) != 0){
		strcpy(mesg, "Could not create a pipe...\n");
		gtk_text_insert(oops_text, NULL, NULL, NULL, mesg, strlen(mesg));
	}
	
	if(pipe(hintPipe) != 0){
		strcpy(mesg, "Could not create a pipe...\n");
		gtk_text_insert(oops_text, NULL, NULL, NULL, mesg, strlen(mesg));
	}

	if(pipe(oopsPipe) != 0){
		strcpy(mesg, "Could not create a pipe...\n");
		gtk_text_insert(oops_text, NULL, NULL, NULL, mesg, strlen(mesg));
	}

	signal(SIGALRM, update_windows);

	timer.it_interval.tv_sec  = 1;
	timer.it_interval.tv_usec = 0;

	timer.it_value.tv_sec  = 1;
	timer.it_value.tv_usec = 0;

	setitimer(ITIMER_REAL, &timer, NULL);

	gtk_main ();
	return 0;
}

/* Handlers for the contents & nic option menus */
static void on_contents_option_selected(GtkMenuShell *menu_shell, gpointer user_data)
{
	GtkWidget       *active_item;

	active_item	= gtk_menu_get_active(GTK_MENU(menu_shell));
	REPEAT_TEST	= g_list_index(menu_shell->children, active_item);
}

static void on_nic_option_selected(GtkMenuShell *menu_shell, gpointer user_data)
{
	GtkWidget       *active_item;

	active_item	= gtk_menu_get_active(GTK_MENU(menu_shell));
	nic		= g_list_index(menu_shell->children, active_item);
}

static void update_windows(int a)
{
	char            temp[300];
	int             i,n;
	
	GdkColormap	*cmap;
	GdkColor	color;

	
	/* To make sure that the reads below donot block */
	fcntl(statusPipe[0],  F_SETFL, O_NONBLOCK);
	fcntl(hintPipe[0],  F_SETFL, O_NONBLOCK);
	fcntl(oopsPipe[0],  F_SETFL, O_NONBLOCK);

	
	cmap = gdk_colormap_get_system();
	color.red = 0;
	color.green = 0;
	color.blue = 0xffff;
	if (!gdk_color_alloc(cmap, &color)){
		printf("couldn't allocate color");
	}
	n = read(statusPipe[0], temp, sizeof(temp));
	for(i=0; i<n; i++)
		gtk_text_insert(status_text, NULL, &color, NULL, &temp[i], 1);

	
	color.red = 0;
	color.green = 0xaaaa;
	color.blue = 0;
	if (!gdk_color_alloc(cmap, &color)){
		printf("couldn't allocate color");
	}
	n = read(hintPipe[0], temp, sizeof(temp));
	for(i=0; i<n; i++)
		gtk_text_insert(hint_text, NULL, &color, NULL, &temp[i], 1);


	color.red = 0xffff;
	color.green = 0;
	color.blue = 0;
	if (!gdk_color_alloc(cmap, &color)){
		printf("couldn't allocate color");
	}
	n = read(oopsPipe[0], temp, sizeof(temp));
	for(i=0; i<n; i++)
		gtk_text_insert(oops_text, NULL, &color, NULL, &temp[i], 1);

	return;
}

