#include "WLANWatch-Client.h"

extern int	clientUp;
extern int	statusPipe[];
extern int	hintPipe[];
extern int	oopsPipe[];

extern void	writeToPipe(int fd, char *str);

extern int 	WLANWatchC_Setup(void);
extern int 	WLANWatchC_StartSniffer(void);
extern int 	TxLoger_Start(void);
extern int 	TrafficGenerator(void);
extern int 	TxLoger_Stop(void);
extern int 	WLANWatchC_StopSniffer(void);

static char	mesg[300];
static void	cleanup_WLANWatch_client(void);

void 		*on_start(void *arg);

char		sniff_MAC[20];
int		WLANWatchCsockfd;

static void cleanup_WLANWatch_client()
{
	clientUp = 0;
	strcpy(mesg, "WLANWatch Client : Session Terminating...\n\n");
	writeToPipe(statusPipe[1], mesg);
	pthread_exit(NULL);
}

void *on_start(void *arg)
{
	sigset_t                mask;

	sigfillset(&mask);
	pthread_sigmask(SIG_BLOCK, &mask, NULL);
			
	/* 
	 * 1. Setup the Client (WLANWatchC).
	 */
	if( (WLANWatchC_Setup()) == -1){
		cleanup_WLANWatch_client();
	}

	/* 
	 * 2. Ask the Client (WLANWatchC) to start the remote sniffer on specified 
	 * "remote_sniff_channel" and sniff the packets originating from specified "sniff_MAC".
	 * It talks to the Remote Sniffing Server (WLANWatchS) and sets up the remote Rx Loger 
	 * to sniff the traffic dumped through client's Wireless interface.
	 */
	if(WLANWatchC_StartSniffer() == -1){
		cleanup_WLANWatch_client();
	}

	/* 
	 * 3. Start the Tx Loger to log the traffic generated - is to be formatted later.	
	 */
	if(TxLoger_Start() == -1){
		cleanup_WLANWatch_client();
	}
	
	/* 
	 * 4. Start the Traffic Generator to pump the traffic.
	 */
	if(TrafficGenerator() == -1){
		cleanup_WLANWatch_client();
	}

	sleep(2);
	
	/* 
	 * 5. Stop the Tx Loger.
	 */
	if(TxLoger_Stop() == -1){
		cleanup_WLANWatch_client();
	}
	
	/* 
	 * 6. Ask the WLANWatchC to stop the remote sniffer. This talks to the WLANWatchS and gets the 
	 * remote sniffer, the Rx Loger to stop.
	 */
	if(WLANWatchC_StopSniffer() == -1){
		cleanup_WLANWatch_client();
	}

	strcpy(mesg, "Hit 'Statistics' to display the statistics...\n");
	writeToPipe(statusPipe[1], mesg);
	pthread_exit(NULL);
}
