#include "WLANWatch-Client.h"

extern int	statusPipe[];
extern int	hintPipe[];
extern int	oopsPipe[];
extern int	clientUp;
extern int	stats_clicked;

extern pthread_t	on_start_thread;

extern int	WLANWatchCsockfd;

extern void	writeToPipe(int fd, char *str);

extern int	import_RxLog(void);
extern int	format_TxLog(void);
extern int	process_TxRxLogs(void);

static char	mesg[300];

static void 	cleanup_on_stats(void);
void 		*on_stats(void *arg);

static void cleanup_on_stats()
{
	clientUp = 0;
	strcpy(mesg, "WLANWatch Client : Session Terminating...\n\n");
	writeToPipe(statusPipe[1], mesg);
	stats_clicked = 0;
	pthread_exit(NULL);
}

void *on_stats(void *arg)
{
	sigset_t                mask;

	sigfillset(&mask);
	pthread_sigmask(SIG_BLOCK, &mask, NULL);

	if(pthread_join(on_start_thread, NULL)){
		clientUp = 0;
		stats_clicked = 0;
		pthread_exit(NULL);
	}
	if(!clientUp)
		cleanup_on_stats();
	
	/*
	 * Get the RxLog file from the WLANWatch Server.
	 */
        if(import_RxLog() == -1){
		cleanup_on_stats();
        }

        /* Close the connection with the RSS */
        close(WLANWatchCsockfd);
	WLANWatchCsockfd = 0;

        /*
	 * Remove the unwanted info from the TxLog_temp & write the formatted
	 * stuff to TxLog.
	 */
        if(format_TxLog() == -1){
		cleanup_on_stats();
	}

        /*
	 * Process the Tx & Rx Log files as needed.
	 */
        if(process_TxRxLogs() == -1){
		cleanup_on_stats();
	}

	clientUp = 0;
	strcpy(mesg, "WLANWatch Client : Session Closed...\n\n");
	writeToPipe(statusPipe[1], mesg);

	strcpy(mesg, "Hit 'Start' to repeat the process...\n");
	writeToPipe(hintPipe[1], mesg);

	stats_clicked = 0;
	pthread_exit(NULL);
}
